﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Private lblEndAddr As B4XView
	Private lblFree As B4XView
	Private lblRegion As B4XView
	Private lblSize As B4XView
	Private lblStartAddr As B4XView
	Private lblUsed As B4XView
	Private regionItemProgIndicator As B4XView

	Private xListMemRegions As CustomListView
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
'  	Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props

	mBase.LoadLayout("regionViewLayout.bjl")
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

'======================================================================================================
Private Sub createRegionItem(reg As regItem_t) As Pane
'	Dim p As B4XView = xui.CreatePanel("")
	Dim p As AnchorPane
	p.Initialize("")
	p.LoadLayout("regionItemLayout.bjl")
	p.SetSize(710dip, 65dip)
	
'	p.SetLayoutAnimated(0, 0, 0, 710dip, 65dip)
'	p.LoadLayout("regionItemLayout")
	
'	iv.lblRegion 	= lblRegion
'	iv.lblStartAddr = lblStartAddr
'	iv.lblEndAddr 	= lblEndAddr
'	iv.lblSize 		= lblSize
'	iv.lblUsed 		= lblUsed
'	iv.lblFree 		= lblFree
'	iv.regionItemProgIndicator = regionItemProgIndicator
	
'	
'	iv.lblRegion.Text 		= reg.regionName
'	iv.lblStartAddr.Text   = LongIntToHex(reg.startAddress)
'	iv.lblEndAddr.Text		= LongIntToHex(reg.EndAddress)
'	iv.lblSize.Text 		= LongIntToHex(reg.MaxSize)
'	
'	If reg.regUsed < 1000 Then
'		NumberFormat(reg.regUsed, 1, 0)
'		iv.lblUsed.Text = reg.regUsed
'	Else if reg.regUsed >= 1000 And reg.regUsed < 1000000 Then
'		NumberFormat(reg.regUsed / 1000, 1, 2)
'		iv.lblUsed.Text = reg.regUsed / 1000
'	Else if reg.regUsed >= 1000000 Then
'		NumberFormat(reg.regUsed / 1000000, 1, 2)
'		iv.lblUsed.Text = reg.regUsed / 1000000
'	End If
'	
'	If reg.regFree < 1000 Then
'		NumberFormat(reg.regFree, 1, 0)
'		iv.lblFree.Text = reg.regFree
'	Else if reg.regFree >= 1000 And reg.regFree < 1000000 Then
'		NumberFormat(reg.regFree / 1000, 1, 2)
'		iv.lblUsed.Text = reg.regFree / 1000
'	Else if reg.regFree >= 1000000 Then
'		NumberFormat(reg.regFree / 1000000, 1, 2)
'		iv.lblUsed.Text = reg.regFree / 1000000
'	End If

	Return p
End Sub

Public Sub addRegionToRegList(mapDB_RegionList As List)
	For m = 0 To mapDB_RegionList.Size - 1
		Dim row() As Object
		row = mapDB_RegionList.Get(m)
		Dim reg As regItem_t
		Dim iv As regItemFields
		iv.Initialize
		reg.Initialize
		
		reg.regionName = row(1)
		reg.startAddress = row(6)
		reg.EndAddress = row(8)
		reg.MaxSize = row(9)
		reg.regFree = row(10)
		reg.regUsed = row(11)
		xListMemRegions.Add(createRegionItem(reg), 0)
	Next
End Sub